#!/usr/bin/perl
# /*********************************************************************************
# **
# **   $Id: movedb.pl,v 1.7 2004/05/04 01:05:00 croftj Exp $
# **   Copyright (c) 2004 Joe Croft <joe@croftj.net>
# **   
# **   This file is part of ah2.
# **
# **   ah2 is free software; you can redistribute it and/or modify
# **   it under the terms of the GNU General Public License as published by
# **   the Free Software Foundation; either version 2 of the License, or
# **   (at your option) any later version.
# **
# **   Foobar is distributed in the hope that it will be useful,
# **   but WITHOUT ANY WARRANTY; without even the implied warranty of
# **   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# **   GNU General Public License for more details.
# **
# **   You should have received a copy of the GNU General Public License
# **   along with Foobar; if not, write to the Free Software
# **   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# **
# *********************************************************************************/

use DBI;

$| = 1;

$db   = DBI->connect("dbi:Pg:dbname=autohouse", "croftj");
$db2  = DBI->connect("dbi:Pg:dbname=ah2", "croftj");

$sql = "delete from wo_parts";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from wo_labor";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from workorders";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from vehicles where ident > 1";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from customers where ident > 1";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from duplicate_vehicles";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from dropped_vehicles";
print "$sql\n";
$db2->do($sql) || die;
$sql = "delete from parts";
print "$sql\n";
$db2->do($sql) || die;

$sql = "select pn, make, descr, lowmark, buylevel, onhand, location, category, list, hours, ident) from parts";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
      $r->[0] =~ s/\s+$//;
      $pn = $db->quote($r->[0]);
      $r->[1] =~ s/\s+$//;
      $make = $db->quote($r->[1]);
      $r->[2] =~ s/\s+$//;
      $descr = $db->quote($r->[2]);
      $r->[3] =~ s/\s+$//;
      $lowmark = $db->quote($r->[3]);
      $r->[4] =~ s/\s+$//;
      $buylevel = $db->quote($r->[4]);
      $r->[5] =~ s/\s+$//;
      $onhand = $db->quote($r->[5]);
      $r->[6] =~ s/\s+$//;
      $location = $db->quote($r->[6]);
      $r->[7] =~ s/\s+$//;
      $category = $db->quote($r->[7]);
      $r->[8] =~ s/\s+$//;
      $list = $db->quote($r->[8]);
      $r->[9] =~ s/\s+$//;
      $hours = $db->quote($r->[9]);
      $r->[10] =~ s/\s+$//;
      $ident = $db->quote($r->[10]);
      $sql = <<SQLEND;
         insert into parts (pn, make, category, descr, lowmark, buylevel, onhand, location, measure, cost, retail, supply)
            values($pn, $make, $category, $descr, $lowmark, $buylevel, $onhand, $location, 'Ea.', '0.00', $list, 'N');
SQLEND
      print "$sql\n";
      $db2->do($sql) || die;
}
$sql = "select max(ident) from parts";
print "$sql\n";
$sth = $db2->prepare($sql);
$sth->execute();
if (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0]++;
   $ident = $db2->quote($r->[0]);
   $sql = "select setval('parts_ident_seq', $ident)";
   print "$sql\n";
   $db2->do($sql) || die;
}




$sql = "select name, addr, city, state, zip, homephone, workphone, beeper, tax_id, ident from customers order by ident";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
#   print "$r->[9]\t$r->[0]\n";
   if ( $r->[9] >= 6 ) {
      $r->[0] =~ s/\s+$//;
      $name = $db->quote($r->[0]);
      $r->[1] =~ s/\s+$//;
      $addr = $db->quote($r->[1]);
      $r->[2] =~ s/\s+$//;
      $city = $db->quote($r->[2]);
      $r->[3] =~ s/\s+$//;
      $state = $db->quote($r->[3]);
      $r->[4] =~ s/\s+$//;
      $zip = $db->quote($r->[4]);
      $r->[5] =~ s/\s+$//;
      $home_pn = $db->quote($r->[5]);
      $r->[6] =~ s/\s+$//;
      $work_pn = $db->quote($r->[6]);
      $r->[7] =~ s/\s+$//;
      $beeper = $db->quote($r->[7]);
      $r->[8] =~ s/\s+$//;
      $tax_id = $db->quote($r->[8]);
      $r->[9] =~ s/\s+$//;
      $ident = $db->quote($r->[9]);
      $sql = "insert into customers (name, addr, city, state, zip, home_pn, work_pn, beeper, tax_id, ident) values " .
                    "($name, $addr, $city, $state, $zip, $home_pn, $work_pn, $beeper, $tax_id, $ident)";
      print "$sql\n";
      $db2->do($sql) || die;
   }
}
$sth->finish;

$sql = "select max(ident) from customers";
print "$sql\n";
$sth = $db2->prepare($sql);
$sth->execute();
if (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0]++;
   $ident = $db2->quote($r->[0]);
   $sql = "select setval('customers_ident_seq', $ident)";
   print "$sql\n";
   $db2->do($sql) || die;
}
$sth->finish;


$sql = "select make, model, year, color, tag, vin, engine, trans, odom, owner, ident from vehicles order by vin desc, tag desc, ident desc";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
   $make = $r->[0];
   $make =~ s/\s+$//;
   $r->[1] =~ s/\s+$//;
   $model = $db->quote($r->[1]);
   $r->[2] =~ s/\s+$//;
   $model_yr = $db->quote($r->[2]);
   $r->[3] =~ s/\s+$//;
   $color = $db->quote($r->[3]);
   $r->[4] =~ s/\s+$//;
   $tag = $db->quote($r->[4]);
   $r->[5] =~ s/\s+$//;
   $vin = $db->quote($r->[5]);
   $r->[6] =~ s/\s+$//;
   $engine = $db->quote($r->[6]);
   $r->[7] =~ s/\s+$//;
   $trans = $db->quote($r->[7]);
   $r->[8] =~ s/\s+$//;
   $odom = $db->quote($r->[8]);
   $r->[9] =~ s/\s+$//;
   $owner = $db->quote($r->[9]);
   $r->[10] =~ s/\s+$//;
   $ident = $db->quote($r->[10]);

   $new_make = $make;
   if ( $make =~ /^AUDI/) {
      $new_make = "Audi";
   }
   elsif ( $make eq "ACCURA" ||
           $make eq "ACURA") {
      $new_make = "Accura";
   }
   elsif ( $make eq "MB" ||
        $make eq "MBZ" || 
        $make eq "MERCEDES" || 
        $make eq "MERCEDES 300 SD" || 
        $make eq "MERCEDES BENZ" || 
        $make eq "MERCEDES-BENZ" || 
        $make eq "MERCEDEZ" || 
        $make eq "MERCEDEZ BENZ" || 
        $make eq "DAIMLER B." || 
        $make eq "DB" || 
        $make eq "SL"
        ) {
      $new_make = "Mercedes";
   }
   elsif ( $make eq "CHAVY" ||
           $make =~ /^CHEV/) {
      $new_make = "Chevrolet";
   }
   elsif ( $make eq "DOGDE" ||
           $make eq "DOGGE" ||
           $make eq "DOOGE" ) {
      $new_make = "Dodge";
   }
   elsif ( $make =~ /^GM/ ) {
      $new_make = "GMC";
   }
   elsif ( $make =~ /^IZUZU/ ) {
      $new_make = "Izuzu";
   }
   elsif ( $make =~ /^JAG/ ) {
      $new_make = "Jaguar";
   }
   elsif ( $make eq "LEW" ||
           $make eq "LEXES") {
      $new_make = "Lexus";
   }
   elsif ( $make eq "LINCON" ) {
      $new_make = "Lincoln";
   }
   elsif ( $make eq "MZADA" ) {
      $new_make = "Mazda";
   }
   elsif ( $make =~ /^TOYTA/ ) {
      $new_make = "Toyota";
   }
   elsif ( $make eq "VLVO" ||
           $make eq "OLVO" ||
   $       $make eq "VOLVOL" ) {
      $new_make = "Volvo";
   }
   elsif ( $make =~ /^VOLKS/ ||
           $make eq "VW"
         ) {
      $new_make = "Volkswagon";
   }
   if ( $new_make ne "BMW" &&
        $new_make ne "GMC" ) {
      $new_make =~ tr/A-Z/a-z/;
      $new_make =~ s/^([a-z])//;
      $fl = $1;
      $fl =~ tr/a-z/A-Z/;
      $new_make = $fl . $new_make;
   }
   $make = $db->quote($make);
   $new_make = $db->quote($new_make);

   print "$make ==> |$new_make|\n";

   $sql = "select ident from vehicles where owner = $owner and make = $make and model = $model and model_yr = $model_yr";
   $sth1 = $db2->prepare($sql);
   $sth1->execute();

   if (($r1 = $sth1->fetchrow_arrayref) == undef) {
      if ( $r->[9] >= 6 and "$r->[0]" ne ""  and "$r->[1]" ne "") {
         $sql = "insert into vehicles (make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident) values " .
                                     "($new_make, $model, $model_yr, $color, $tag, $vin, $engine, $trans, $odom, $owner, $ident)";
         print "$sql\n";
         $db2->do($sql) || die;
      }
      else {
         $sql = "insert into dropped_vehicles (make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident) values " .
                                     "($new_make, $model, $model_yr, $color, $tag, $vin, $engine, $trans, $odom, $owner, $ident)";
         print "DROPPING: $sql\n";
         print STDERR "DROPPING: $sql\n";
         $db2->do($sql) || die;
      }
   }
   else {
      print "$sql\n";
      print STDERR "$sql\n";
      $db2->do($sql) || die;
      $sql = "insert into vehicles (make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident) values " .
                                    "($new_make, $model, $model_yr, $color, $tag, $vin, $engine, $trans, $odom, $owner, $ident)";
      print "DUPLICATE: $sql\n";
      print STDERR "DUPLICATE: $sql\n";
      $sql = "insert into duplicate_vehicles (original, duplicate) values ($r1->[0], $ident)";
      print "$sql\n";
      print "DUPLICATE: $sql\n";
      print STDERR "DUPLICATE: $sql\n";
      $db2->do($sql) || die;
   }
}
$sth->finish;


$sql = "select max(ident) from vehicles";
print "$sql\n";
$sth = $db2->prepare($sql);
$sth->execute();
if (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0]++;
   $ident = $db2->quote($r->[0]);
   $sql = "select setval('vehicles_ident_seq', $ident)";
   print "$sql\n";
   $db2->do($sql) || die;
}
$sth->finish;



$sql = "select date_in, date_out, odin, odout, rservice1, rservice2, rservice3, rservice4, customer, vehicle, r_labor, r_tax, hazmat, labor, parts, tax, total, ident from job order by ident";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0] =~ s/\s+$//;
   $date_in = $db->quote($r->[0]);
   $r->[1] =~ s/\s+$//;
   $date_out = $db->quote($r->[1]);
   $r->[2] =~ s/\s+$//;
   $od_in = $db->quote($r->[2]);
   $r->[3] =~ s/\s+$//;
   $od_out = $db->quote($r->[3]);
   $r->[4] =~ s/\s+$//;
   $recomend = $r->[4];
   $recomend .= $r->[5];
   $recomend .= $r->[6];
   $recomend .= $r->[7];
   $recomend = $db->quote($recomend);
   $r->[8] =~ s/\s+$//;
   $customer = $db->quote($r->[8]);
   $r->[9] =~ s/\s+$//;
   $vehicle = $db->quote($r->[9]);
   $r->[10] =~ s/\s+$//;
   $r->[10] =~ s/[\$,]//g;
   $r_labor = $db->quote($r->[10]);
   $r->[11] =~ s/\s+$//;
   $r_tax = $db->quote($r->[11]);
   $r->[12] =~ s/\s+$//;
   $r->[12] =~ s/[\$,]//g;
   $hazmat = $db->quote($r->[12]);
   $r->[13] =~ s/\s+$//;
   $r->[13] =~ s/[\$,]//g;
   $labor = $db->quote($r->[13]);
   $r->[14] =~ s/\s+$//;
   $r->[14] =~ s/[\$,]//g;
   $parts = $db->quote($r->[14]);
   $r->[15] =~ s/\s+$//;
   $r->[15] =~ s/[\$,]//g;
   $tax = $db->quote($r->[15]);
   $r->[16] =~ s/\s+$//;
   $r->[16] =~ s/[\$,]//g;
   $total = $db->quote($r->[16]);
   $r->[17] =~ s/\s+$//;
   $ident = $db->quote($r->[17]);

   $sql = "insert into workorders " .
                 "(ident, closed, recorded, date_in, date_out, od_in, od_out, recomend, customer, vehicle, r_labor, r_tax, hazmat, labor, parts, tax, total) values " .
                 "($ident, 'N', 'N', $date_in, $date_out, $od_in, $od_out, $recomend, $customer, $vehicle, $r_labor, $r_tax, $hazmat, $labor, $parts, $tax, $total)";

   $sql1 = "select make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident from dropped_vehicles where ident = $vehicle";
   $sth1 = $db2->prepare($sql1);
   $sth1->execute;
   if ( ($r1 = $sth1->fetchrow_arrayref) ne undef ) {
      $r1->[0] =~ s/\s+$//;
      $make = $db->quote($r1->[0]);
      $r1->[1] =~ s/\s+$//;
      $model = $db->quote($r1->[1]);
      $r1->[2] =~ s/\s+$//;
      if ( "$r1->[2]" eq "") {
         $r1->[2] = "0";
      }
      $model_yr = $db->quote($r1->[2]);
      $r1->[3] =~ s/\s+$//;
      $color = $db->quote($r1->[3]);
      $r1->[4] =~ s/\s+$//;
      $tag = $db->quote($r1->[4]);
      $r1->[5] =~ s/\s+$//;
      $vin = $db->quote($r1->[5]);
      $r1->[6] =~ s/\s+$//;
      $engine = $db->quote($r1->[6]);
      $r1->[7] =~ s/\s+$//;
      $trans = $db->quote($r1->[7]);
      $r1->[8] =~ s/\s+$//;
      $odom = $db->quote($r1->[8]);

      $sql1 = "insert into vehicles (make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident) values " .
                                    "($make, $model, $model_yr, $color, $tag, $vin, $engine, $trans, $odom, $customer, $vehicle)";
      print "MOVING VEHICLE FROM DROPPED VEHICLE TABLE $sql1\n";
      print STDERR "MOVING VEHICLE FROM DROPPED VEHICLE TABLE $sql1\n";
      $db2->do($sql1) || die;
   }
   $sth1->finish;
   print "$sql\n";
   $db2->do($sql) || die;
}
$sth->finish;

$sql = "select date_in, date_out, odin, odout, rservice1, rservice2, rservice3, rservice4, customer, vehicle, r_labor, r_tax, hazmat, labor, parts, tax, total, jobindex from jobarchive order by jobindex";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0] =~ s/\s+$//;
   $date_in = $db->quote($r->[0]);
   $r->[1] =~ s/\s+$//;
   $date_out = $db->quote($r->[1]);
   $r->[2] =~ s/\s+$//;
   $od_in = $db->quote($r->[2]);
   $r->[3] =~ s/\s+$//;
   $od_out = $db->quote($r->[3]);
   $r->[4] =~ s/\s+$//;
   $r->[5] =~ s/\s+$//;
   $r->[6] =~ s/\s+$//;
   $r->[7] =~ s/\s+$//;
   $recomend = $r->[4];
   $recomend .= " $r->[5]";
   $recomend .= " $r->[6]";
   $recomend .= " $r->[7]";
   $recomend =~ s/\s+$//;
   $recomend = $db->quote($recomend);
   $r->[8] =~ s/\s+$//;
   $customer = $db->quote($r->[8]);
   $r->[9] =~ s/\s+$//;
   if ( $r->[9] < 1) {
      $r->[9] = "1";
   }
   $vehicle = $db->quote($r->[9]);
   $r->[10] =~ s/\s+$//;
   $r->[10] =~ s/[\$,]//g;
   $r_labor = $db->quote($r->[10]);
   $r->[11] =~ s/\s+$//;
   $r_tax = $db->quote($r->[11]);
   $r->[12] =~ s/\s+$//;
   $r->[12] =~ s/[\$,]//g;
   $hazmat = $db->quote($r->[12]);
   $r->[13] =~ s/[\$,]//g;
   $r->[13] =~ s/\s+$//;
   $labor = $db->quote($r->[13]);
   $r->[14] =~ s/\s+$//;
   $r->[14] =~ s/[\$,]//g;
   $parts = $db->quote($r->[14]);
   $r->[15] =~ s/\s+$//;
   $r->[15] =~ s/[\$,]//g;
   $tax = $db->quote($r->[15]);
   $r->[16] =~ s/\s+$//;
   $r->[16] =~ s/[\$,]//g;
   $total = $db->quote($r->[16]);
   $r->[17] =~ s/\s+$//;
   $ident = $db->quote($r->[17]);

   $sql1 = "select original from duplicate_vehicles where duplicate = $vehicle";
   $sth1 = $db2->prepare($sql1);
   $sth1->execute();
   if (($r1 = $sth1->fetchrow_arrayref) != undef) {
      $r1->[0] =~ s/\s+$//;
      if ( $r1->[0] < 1) {
         $r1->[0] = "1";
      }
      my $orig = $vehicle;
      $vehicle = $db->quote($r1->[0]);
      print "USING DUPLICATE VEHICLE: Found: $orig, Using = $vehicle\n";
      print STDERR "USING DUPLICATE VEHICLE: Found: $orig, Using = $vehicle\n";
   }
   $sth1->finish;

   $sql = "insert into workorders " .
                 "(ident, closed, recorded, date_in, date_out, od_in, od_out, recomend, customer, vehicle, r_labor, r_tax, hazmat, labor, parts, tax, total) values " .
                 "($ident, 'Y', 'N', $date_in, $date_out, $od_in, $od_out, $recomend, $customer, $vehicle, $r_labor, $r_tax, $hazmat, $labor, $parts, $tax, $total)";
   print "$sql\n";

   $sql1 = "select make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident from dropped_vehicles where ident = $vehicle";
   $sth1 = $db2->prepare($sql1);
   $sth1->execute;
   if ( ($r1 = $sth1->fetchrow_arrayref) ne undef ) {
      $r1->[0] =~ s/\s+$//;
      $make = $db->quote($r1->[0]);
      $r1->[1] =~ s/\s+$//;
      $model = $db->quote($r1->[1]);
      $r1->[2] =~ s/\s+$//;
      if ( "$r1->[2]" eq "") {
         $r1->[2] = "0";
      }
      $model_yr = $db->quote($r1->[2]);
      $r1->[3] =~ s/\s+$//;
      $color = $db->quote($r1->[3]);
      $r1->[4] =~ s/\s+$//;
      $tag = $db->quote($r1->[4]);
      $r1->[5] =~ s/\s+$//;
      $vin = $db->quote($r1->[5]);
      $r1->[6] =~ s/\s+$//;
      $engine = $db->quote($r1->[6]);
      $r1->[7] =~ s/\s+$//;
      $trans = $db->quote($r1->[7]);
      $r1->[8] =~ s/\s+$//;
      $odom = $db->quote($r1->[8]);
      $sql1 = "insert into vehicles (make, model, model_yr, color, tag, vin, engine, trans, odom, owner, ident) values " .
                                    "($make, $model, $model_yr, $color, $tag, $vin, $engine, $trans, $odom, $customer, $vehicle)";
      print "MOVING VEHICLE FROM DROPPED VEHICLE TABLE $sql1\n";
      print STDERR "MOVING VEHICLE FROM DROPPED VEHICLE TABLE $sql1\n";
      $db2->do($sql1) || die;
      $sql1 = "delete from dropped_vehicles where ident = $vehicle";
      print STDERR "DELETING FROM DROPPED VEHICLE TABLE $sql1\n";
      $db2->do($sql1) || die;
   }

   $sql1 = "select customer, vehicle, total, parts, labor, date_in from workorders where ident = $ident";
   $sth1 = $db2->prepare($sql1);
   $sth1->execute();
   if (($r1 = $sth1->fetchrow_arrayref) == undef) {
      $db2->do($sql) || print STDERR "sql = $sql\n\n";
   }
   else {
      print "Moving Duplicate job indent for date_in: $r1->[5], cust: $r1->[0], vehc: $r1->[1], total: $r1->[2], parts: $r1->[3], labor: $r1->[4]\n";
      print STDERR "Moving Duplicate job indent for date_in: $r1->[5], cust: $r1->[0], vehc: $r1->[1], total: $r1->[2], parts: $r1->[3], labor: $r1->[4]\n";
      $sql1 = "update workorders set ident = ident-10000 where ident=$ident";
      print "$sql1\n";
      $db2->do($sql1) || die;
      $db2->do($sql) || print STDERR "sql = $sql\n\n";;
   }
}                                            
$sth->finish;

$sql = "select max(ident) from workorders";
print "$sql\n";
$sth = $db2->prepare($sql);
$sth->execute();
if (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0]++;
   $ident = $db2->quote($r->[0]);
   $sql = "select setval('workorders_ident_seq', $ident)";
   print "$sql\n";
   $db2->do($sql) || die;
}
$sth->finish;

$sql = "update workorders set total = hazmat + labor + parts + tax";
$db2->do($sql) || print STDERR "$sql\n";


$sql = "select number, descr,qty, cost, taxable, supply, inventory, job, ident from jobparts";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0] =~ s/\s+$//;
   $pn = $db->quote($r->[0]);
   $r->[1] =~ s/\s+$//;
   $descr = $db->quote($r->[1]);
   $r->[2] =~ s/\s+$//;
   $qty = $db->quote($r->[2]);
   $r->[3] =~ s/\s+$//;
   $r->[3] =~ s/[\$,]//g;
   $cost = $db->quote($r->[3]);
   $r->[4] =~ s/\s+$//;
   $taxable = $db->quote($r->[4]);
   $r->[5] =~ s/\s+$//;
   $supply = $db->quote($r->[5]);
   $r->[6] =~ s/\s+$//;
   $part = $db->quote($r->[6]);
   $r->[7] =~ s/\s+$//;
   $workorder = $db->quote($r->[7]);

   $sql = "insert into wo_parts (pn, descr, qty, cost, taxable, supply, part, workorder) values " .
                                "($pn, $descr, $qty, $cost, $taxable, $supply, $part, $workorder)";
   print "$sql\n";
   $db2->do($sql) || print STDERR "sql = $sql\n\n";
}
$sth->finish;

$sql = "select descr, tech, hours, job, ident from joblabor";
$sth = $db->prepare($sql);
$sth->execute();
while (($r = $sth->fetchrow_arrayref) != undef) {
   $r->[0] =~ s/\s+$//;
   $descr = $db->quote($r->[0]);
   $r->[1] =~ s/\s+$//;
   $tech = $db->quote($r->[1]);
   $r->[2] =~ s/\s+$//;
   $hours = $db->quote($r->[2]);
   $r->[3] =~ s/\s+$//;
   $workorder = $db->quote($r->[3]);

   $sql = "insert into wo_labor (descr, tech, hours, workorder) values " .
                                "($descr, $tech, $hours, $workorder)";
   print "$sql\n";
   $db2->do($sql) || print STDERR "sql = $sql\n\n";
}
$sth->finish;
